#ifndef __SYS_TYPES_H__
# define __SYS_TYPES_H__

#ifdef __cplusplus
extern "C" {
#endif

#include <stddef.h>
#include <stdint.h>

/* Number of blocks in a file */
typedef uint16_t blkcnt_t;

/* Size of a file block */
typedef uint16_t blksize_t;

/* Device identifier, with a major and minor byte */
typedef uint16_t dev_t;

/* Type of group identifiers on the system */
typedef uint16_t gid_t;

/* Inode number */
typedef uint32_t ino_t;

/* Holds a file's type and permissions bits */
typedef int16_t mode_t;

/* Number of hard links to a file */
typedef uint16_t nlink_t;

/* Offset within a file or stream; also, file size */
typedef int32_t off_t;

/* Process identifier */
typedef int16_t pid_t;

/* Signed size_t which can hold the value -1 */
typedef int32_t ssize_t;

/* Type of user identifiers on the system */
typedef uint16_t uid_t;

#ifdef __cplusplus
}
#endif

#endif /*__SYS_TYPES_H__*/
